<?php

namespace ResourceBundle\Repository;

use Psr\Log\LoggerInterface;
use ResourceBundle\Entity\Province;
use Schema\SchemaEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;
use Utils\StaticUtil\LogUtils;

/**
 * AllergenRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class ProvinceRepository extends SchemaEntityRepository {

    /** @var LoggerInterface $logger */
    private $logger;

    ///////////////////////////////////////////
    /// CONSTRUCTOR

    /**
     * ProvinceRepository constructor.
     * @param ManagerRegistry $registry
     * @param LoggerInterface $logger
     */
    public function __construct(ManagerRegistry $registry, LoggerInterface $logger) {
        parent::__construct($registry, Province::class);

        $this->logger = $logger;
    }


    /**
     * @return array|mixed
     */
    public function findAllProvinces() {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('p')
            ->from('ResourceBundle:Province', 'p')
        ;

        $results = array();

        try {
            $results = $qb->getQuery()->getResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get all provinces", $exception);
        }

        return $results;
    }

    /**
     * @param $country
     * @return mixed|null
     */
    public function findProvincesByCountry($country) {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('p')
            ->from('ResourceBundle:Province', 'p')
            ->where('p.country = :country')
            ->setParameter('country', $country)
        ;

        $results = array();

        try {
            $results = $qb->getQuery()->getResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get provinces by country", $exception);
        }

        return $results;
    }

}
